// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Здесь будут программы для всех процессов

#include "configuration.h"
#include "declarations.h"

void PrepareProcess()
{
	char i;
	// Максимальную температуру процессов зануляем.
	for (i = 0; i < MAX_DS1820; i++)
	{
		Maxtemps[i] = 0;
	}
	// Все таймеры зануляем.
	time1 = 0;
	time2 = 0;
	time3 = 0;
	flAutoDetectPowerTEN = 0;// Убираем признак авто-детектирования ТЭНОв
	flNoAlarmLowPower = NO_LOW_POWER_WARNING;   // Убираем признак невыдачи предупреждения о низком уровне напряжения
	// Все клапана зануляем.
	CloseAllKLP();
}

void ProcessTermostat()
{
	if (ds1820_devices == 0) StateMachine = 100;
	switch (StateMachine)
	{
	case 0: // Процесс не запущен 
	  // Процесс термостат запускается автоматически, чтобы он работал даже если выключат и включат свет.
	  //break;
	case 1: // Старт процесса
		StateMachine = 2;
	case 2: // Основной цикл программы, пытаемся регулировать мощность, не превышая температуру
		if (temps[TEMP_TERMOSTAT] <= TempTerm)
		{
						ProcessPIDTemp(TempTerm, temps[TEMP_TERMOSTAT]);
			UstPower = (long)Power*KtT / 1000;
			// Мощность ограничена установленной мощностью термостата
			if (UstPower > PowerVarkaZerno) UstPower = PowerVarkaZerno;
			break;
		}
		// Температура все-таки стала выше нужной - идем к следующему этапу
		StateMachine = 3;
		// if (BeepStateProcess) my_beep(BEEP_LONG);
	case 3: //
		UstPower = 0; // Убираем мощность с ТЭНов
		if (temps[TEMP_TERMOSTAT] > TempTerm - Delta)
		{
			break;
		}
		// Если температура упала ниже TempTerm-Delta, идем регулировать ТЭНы
		StateMachine = 2;
		// if (BeepStateProcess) my_beep(BEEP_LONG);
		break;
	case 100:// Конечное состояние автомата
		flAllOff = 1;
		UstPower = 0; // Убираем мощность с ТЭНов
		break;
	}
}

void ProcessTimerMaxPower()
{
	int minute;
	switch (StateMachine)
	{
	case 0: // 
	  // Процесс не запущен
		break;
	case 1: // Старт процесса
		timerMinute = 0;
		StateMachine = 2;
	case 2: // Температура Больше необходиомй
		minute = Seconds / 60;
		if (minute <= timerMinute)
		{
			UstPower = PowerMinute; // Подаем полную мощность на ТЭНЫ
			break;
		}
		StateMachine = 100;
		if (BeepStateProcess) my_beep(BEEP_LONG);
	case 100:// Конечное состояние автомата
		if (BeepEndProcess) my_beep(BEEP_LONG);
		flAllOff = 1;
		UstPower = 0; // Убираем мощность с ТЭНов
		break;
	}
}

//    case 110:
// Процесс дистилляции с подключаемым дефлегматором
// Процесс поддерживат температуру в дефлегматоре не более заданной + дельта и не менее заданной - дельта
void ProcessDistilDefl()
{
	if ((temps[TEMP_KUB] >= tEndDistDefl || deltaPower >= Power) && StateMachine < 7)
	{ // Переводим автомат в стадию завершения 
		StateMachine = 7;
		SecondsEnd = 2 * 60 + ((int)(FlAvtonom >> 1)) * 60;// Через одну минуту отключим воду
		SecTempPrev = Seconds;
		if (BeepStateProcess) my_beep(BEEP_LONG);
	}
	// Проверяем температуру в ТСА
	if (temps[TEMP_TSA] >= MAX_TEMP_TSA)
	{
		StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
		UstPower = 0;
	}
	switch (StateMachine)
	{ 
	case 0: // Процесс не запущен
		break;
	case 1: // Начало процесса
		PrepareProcess();

		KlOpen[KLP_VODA] = PER_KLP_OPEN;
		KlClose[KLP_VODA] = PER_KLP_CLOSE;
		StateMachine = 2;//Этот процесс пока заблокирован, сразу идем на окончание.
		flAllOff = 0;
		if (BeepStateProcess) my_beep(BEEP_LONG);
		deltaPower = 0;
	case 2: // Ожидание, пока прогреется термометр в дефлегматоре

		UstPower = Power; // Устанавливаем максимальную мощность для разгона

		// Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
		// дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
		if (temps[TEMP_DEFL] < TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil < 0 && temps[TEMP_KUB] < -TempDeflBegDistil)) break;

		// Подаем питание на клапан подачи воды холодильника
		StateMachine = 3;
		if (BeepStateProcess) my_beep(BEEP_LONG);

	case 3:
		// Ждем, пока температура в кубе не достигнет температуры начала дистилляции (если есть датчик дефлегматора, тогда этот пункт сразу
		// проскочится, поскольку темперетура в кубе не может быть меньше, чем температура в дефлегматоре
		if (temps[TEMP_KUB] < TempDeflBegDistil) break;
		// Подаем питание на клапан подачи воды холодильника

		// Подаем питание на клапан подачи воды холодильника
		// для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
		KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
		KlClose[KLP_HLD] = KlClose[KLP_VODA];
		KlState[KLP_HLD] = KlState[KLP_VODA];
		KlCount[KLP_HLD] = KlCount[KLP_VODA];

		StateMachine = 4;
		time2 = 15 * 60; // Взводиим таймер на 15 минут   
		if (BeepStateProcess) my_beep(BEEP_LONG);

	case 4: // Дефлегматор отключен.
	  // Если более 10 минут не вышли за пределы температуры, тогда увеличиваем мощность.
		if (time2 == 0)
		{
			deltaPower = deltaPower - (int)(PowerDistil / 20);
			if (deltaPower < 0) deltaPower = 0;
			time2 = 10 * 60;
		}

		UstPower = PowerDistil - deltaPower; // Устанавливаем мощность дистилляции.

		if (temps[TEMP_DEFL] > TempDefl)
		{
			// Включаем дефлегматор и холодильник

			KlOpen[KLP_DEFL_D] = KlOpen[KLP_VODA];
			KlClose[KLP_DEFL_D] = KlClose[KLP_VODA];
			KlState[KLP_DEFL_D] = KlState[KLP_VODA];
			KlCount[KLP_DEFL_D] = KlCount[KLP_VODA];

			KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
			KlClose[KLP_HLD] = KlClose[KLP_VODA];
			KlState[KLP_HLD] = KlState[KLP_VODA];
			KlCount[KLP_HLD] = KlCount[KLP_VODA];
			StateMachine = 5; // Переходим к этапу поддержания температуры путем частичной подачи воды в дефлегмато
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		else
			break;
	case 5:// 50% воды из холодильника идет в дефлегматор.
	  // Если более 10 минут не вышли за пределы температуры, тогда увеличиваем мощность.
		time2 = 10 * 60;
		if (time3 == 0)
		{
			deltaPower = deltaPower - (int)(PowerDistil / 30);
			if (deltaPower < 0) deltaPower = 0;
			time3 = 10 * 60;
		}
		UstPower = PowerDistil - deltaPower; // Устанавливаем мощность дистилляции.
		// Если температура превысила температуру, которую надо поддерживать в дефлегматоре+дельта, тогда переходим к режиму, когда
		// вся вода из холодильника идет через дефлегматор
		if (temps[TEMP_DEFL] > TempDefl + DeltaDefl)
		{
			// Отключаем прямой выход из холодильника
			KlOpen[KLP_HLD] = 0;
			KlClose[KLP_HLD] = 10;
			// Включаем дефлегматор
			KlOpen[KLP_DEFL_D] = KlOpen[KLP_VODA];
			KlClose[KLP_DEFL_D] = KlClose[KLP_VODA];
			KlState[KLP_DEFL_D] = KlState[KLP_VODA];
			KlCount[KLP_DEFL_D] = KlCount[KLP_VODA];

			StateMachine = 6; // Переходим к этапу поддержания температуры путем 100% направления воды в дефлегматор        
			time1 = 0;
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		else
			if (temps[TEMP_DEFL] < TempDefl - DeltaDefl) // Если в результате работы с 50% дефлегматором, температура понизилась переходим в режим работы без дефлегматора
			{
				KlOpen[KLP_DEFL_D] = 0;
				KlClose[KLP_DEFL_D] = 10;

				KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
				KlClose[KLP_HLD] = KlClose[KLP_VODA];
				KlState[KLP_HLD] = KlState[KLP_VODA];
				KlCount[KLP_HLD] = KlCount[KLP_VODA];
				StateMachine = 4; // Переходим к этапу без дефлегмации
				if (BeepStateProcess) my_beep(BEEP_LONG);
				break;
			}
			else
				break;
	case 6: // Вся вода из холодильника идет в дефлегматор.
	  // Взводиим таймер на 10 минут
		time3 = 10 * 60;
		UstPower = PowerDistil - deltaPower; // Устанавливаем мощность дистилляции.
		// Если температура превысила требуемую + дельта более, чем на полдельта за три минуты, тогда уменьшааем мощность 
		if (temps[TEMP_DEFL] > TempDefl + DeltaDefl + DeltaDefl / 2)
		{
			if (time1 == 0)
			{
				deltaPower = deltaPower + (int)(PowerDistil / 10);
				time1 = 3 * 60;// Взводим таймер на три минуты.
			}
		}
		if (temps[TEMP_DEFL] < TempDefl) // Если в результате работы с 100% дефлегматором, температура понизилась ниже установленной температуры переходим в режим работы с 50% дефлегма
		{
			// Включаем прямой выход из холодильника.
			KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
			KlClose[KLP_HLD] = KlClose[KLP_VODA];
			KlState[KLP_HLD] = KlState[KLP_VODA];
			KlCount[KLP_HLD] = KlCount[KLP_VODA];

			KlOpen[KLP_DEFL_D] = KlOpen[KLP_VODA];
			KlClose[KLP_DEFL_D] = KlClose[KLP_VODA];
			KlState[KLP_DEFL_D] = KlState[KLP_VODA];
			KlCount[KLP_DEFL_D] = KlCount[KLP_VODA];
			StateMachine = 5; // Переходим к этапу поддержания температуры 50% дефлегмацией
			time2 = 15 * 60; // Взводиим таймер на 15 минут   
			if (BeepStateProcess) my_beep(BEEP_LONG);
			break;
		}
		else
			break;
	case 7:// Ждем минуту для окончания подачи воды
		UstPower = 0;
		SecondsEnd = SecondsEnd - (Seconds - SecTempPrev);
		SecTempPrev = Seconds;
		if (SecondsEnd <= 0)
		{
			// Переводим автомат в конечное состояние
			StateMachine = 100;
			SecondsEnd = Seconds;
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		break;
	case 100:// Конечное состояние автомата
		if (BeepEndProcess) my_beep(BEEP_LONG);
	case 101:
		// Отключаем на всякий случай все!
		if (BeepEndProcess) my_beep(BEEP_LONG);
		UstPower = 0;
		CloseAllKLP();
		flAllOff = 1;
		break;
	}
}
//    case 117:
void ProcessDistillFractional()
{
	if (StateMachine < 4)
	{ // Если сработал датчик уровня, то переходим на следующую фракцию.
		TekFraction++;
		SecTempPrev = Seconds;
		if (TekFraction < CountFractionDist) SetAngle(AngleFractionDist[TekFraction]);
		if (BeepStateProcess) my_beep(BEEP_LONG);
	}
	// Проверяем температуру в ТСА
	if (temps[TEMP_TSA] >= MAX_TEMP_TSA)
	{
		StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
		UstPower = 0;
	}
	switch (StateMachine)
	{
	case 0: // Процесс не запущен
		break;
	case 1: // Начало процесса
		PrepareProcess();

		KlOpen[KLP_VODA] = PER_KLP_OPEN;
		KlClose[KLP_VODA] = PER_KLP_CLOSE;
		StateMachine = 2;
		if (BeepStateProcess) my_beep(BEEP_LONG);
		flAllOff = 0;
	case 2: // Ожидание, пока прогреется термометр в дефлегматоре
		UstPower = Power; // Устанавливаем максимальную мощность для разгона
		// Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
		// дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
		if (temps[TEMP_DEFL] < TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil < 0 && temps[TEMP_KUB] < -TempDeflBegDistil)) break;
		// Подаем питание на клапан подачи воды холодильника
		// для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
		KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
		KlClose[KLP_HLD] = KlClose[KLP_VODA];
		KlState[KLP_HLD] = KlState[KLP_VODA];
		KlCount[KLP_HLD] = KlCount[KLP_VODA];
		StateMachine = 3;
		if (BeepStateProcess) my_beep(BEEP_LONG);
		TekFraction = 0;
		SetAngle(AngleFractionDist[TekFraction]);
		SecTempPrev = Seconds;
	case 3:// Ждем, пока температура в кубе не превысит установленную
		if (TekFraction < CountFractionDist)
		{
			if (TekFraction == 0 && CountFractionDist == 2) // Если число фракций равно ровно две, тогда отбираем первую фракцию через клапан голов, остальные через клапан тела
			{
				// Для первой фракции (считаем ее головами) открываем клапан отбора голов, клапан тела закрываем.
				KlOpen[KLP_SR] = 0;
				KlClose[KLP_SR] = 10;
				KlOpen[KLP_GLV_HVS] = 200;
				KlClose[KLP_GLV_HVS] = 0;
			}
			else
			{   // Для последующих фракций (считаем их телом) клапан тела открываем, клапан голов закрываем.
				KlOpen[KLP_SR] = 200;
				KlClose[KLP_SR] = 0;
				KlOpen[KLP_GLV_HVS] = 0;
				KlClose[KLP_GLV_HVS] = 10;
			}
			UstPower = PowerFractionDist[TekFraction]; // Устанавливаем максимальную мощность для разгона
			TekTemp = TempFractionDist[TekFraction]; //Текущее состояние - первый недробный перегон
			if (TekTemp >= 0) // Значение больше нуля, значит это температура
			{
				if (temps[TEMP_KUB] >= TekTemp)
				{
					TekFraction++;
					SecTempPrev = Seconds;
					if (TekFraction < CountFractionDist) SetAngle(AngleFractionDist[TekFraction]);
				}
			}
			else
			{
				// Значение меньше нуля, значит это время в минутах
				SecOstatok = -((Seconds - SecTempPrev) / 60 + TekTemp);
				// Если времени не осталось, переходим на следующую фракцию  
				if (SecOstatok <= 0)
				{
					TekFraction++;
					SecTempPrev = Seconds;
					if (TekFraction < CountFractionDist) SetAngle(AngleFractionDist[TekFraction]);
				}
			}
			break;
		}
		else
		{
			StateMachine = 4;
			time3 = 2 * 60 + ((int)(FlAvtonom >> 1)) * 60;// Через две минуты отключим воду
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
	case 4:// Ждем минуту для окончания подачи воды
		UstPower = 0;
		// Закрываем клапана на отбор.
		KlOpen[KLP_SR] = 0;
		KlClose[KLP_SR] = 10;
		KlOpen[KLP_GLV_HVS] = 0;
		KlClose[KLP_GLV_HVS] = 10;
		if (time3 == 0)
		{
			// Переводим автомат в конечное состояние
			StateMachine = 100;
			SecondsEnd = Seconds;
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		break;
	case 101: // Превышение температуры в ТСА!!!
		my_beep(3 * BEEP_LONG);
	case 100:// Конечное состояние автомата
	  // Отключаем на всякий случай все!
		if (BeepEndProcess) my_beep(BEEP_LONG);
		UstPower = 0;
		CloseAllKLP();
		flAllOff = 1;
		break;
	}
}
//    case 109: //Текущее состояние - ректификация
void ProcessRectif()
{
	static char OldStateMachine = 0;	// Количество срабатываний датчика проводимости для окончания отбора голов.
	int V3; // Текущий уровень проводимости;
	if (StateMachine < 8)
	{ // Переводим автомат в стадию завершения 
				OldStateMachine = StateMachine;
				StateMachine = 9;  // Переводим в режим ожидания
				if (BeepStateProcess) my_beep(BEEP_LONG);
				KlOpen[KLP_GLV_HVS] = 0;
				KlClose[KLP_GLV_HVS] = 100;
				KlOpen[KLP_SR] = 0;
				KlClose[KLP_SR] = 100;
	}
	// Проверяем температуру в ТСА
	if (temps[TEMP_TSA] >= MAX_TEMP_TSA)
	{
		StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
	}
	// Проверяем окончание температуры окончания ректификации
	// Окончание ректификации также определяется, если шим меньше нуля, для этого минимальный шим  надо поставить 0
	if ((temps[TEMP_KUB] >= tEndRect) && StateMachine < 8 && IspReg == 109)
	{
		StateMachine = 8;
		SecTempPrev = Seconds;// Запомним время, когда закончилась ректификация
		if (BeepStateProcess) my_beep(BEEP_LONG);
	}
	switch (StateMachine)
	{
	case 0: // Процесс не запущен
		break;
	case 1: // Начало процесса
		PrepareProcess();
#if ADJUST_COLUMN_STAB_TEMP
		lastStableT = 0;	// Обнуляем нашу температуру, чтобы в Case 6 подхватило текущую
		SecTempPrev2 = 0;   // Обнуляем счетчик времени
#endif // ADJUST_COLUMN_STAB_TEMP

    KlReg[KLP_GLV_HVS] = PEREGREV_ON;
    KlReg[KLP_SR] = PEREGREV_ON;

		KlOpen[KLP_VODA] = PER_KLP_OPEN;
		KlClose[KLP_VODA] = PER_KLP_CLOSE;

		flAllOff = 0;
		StateMachine = 2;
		if (BeepStateProcess) my_beep(BEEP_LONG);
		if (CntCHIM < 0) CntCHIM = -1;
	case 2: // Разгон
		UstPower = Power; // Устанавливаем максимальную мощность для разгона
		// Учитываем как температуру в кубе, так и температуру в колонне, в зависимости от того, положительные или отрицательные значения температур.
		if (temps[TEMP_KUB] < tEndRectRazgon  && tEndRectRazgon>0) break;
		if (temps[TEMP_RK20] < -tEndRectRazgon && tEndRectRazgon <= 0) break;
		// Подаем питание на клапан дефлегматора
		KlOpen[KLP_DEFL] = PER_KLP_OPEN;
		KlClose[KLP_DEFL] = PER_KLP_CLOSE;
		TempPrev = temps[TEMP_RK20];
		SecTempPrev = Seconds; // Запоминаем дату последнего изменения температуры
		StateMachine = 3;
		if (BeepStateProcess) my_beep(BEEP_LONG);
	case 3:// Стабилизация температуры
		UstPower = PowerRect;
		if (temps[TEMP_RK20] > 0) // Если температура больше 70 градусов (вдруг куб прогрелся, а колонна еще нет, нелогично, конечно, но на всякий случай учтем)
		{
			if (TimeStabKolonna >= 0)  // Если время стабилизации колонны больше нуля, то тогда считаем время относительно последнего изменения температуры
			{
				if (abs(temps[TEMP_RK20] - TempPrev) < 2) //Если текущая температура колонны равна температуре, запомненной ранее за исключением погрешности 0,2 градуса
				{
					if (Seconds - SecTempPrev > TimeStabKolonna) //Если с момента последнего измерения прошло более 600 секунд (10 минут), тогда считаем, что температура в колоенне стабилизировалась
					{
						// Переходим к следующему этапу - отбору голов. 
						StateMachine = 4;
						if (BeepStateProcess) my_beep(BEEP_LONG);
						SecTempPrev = Seconds;
					}
					else
						break;
				}
				else
				{
					TempPrev = temps[TEMP_RK20];// Запоминаем температуру
					SecTempPrev = Seconds; // Запоминаем время последнего изменения температуры
					break;
				}
			}
			else
			{
				// Если время стабилизации колонны меньше нуля, то тогда считаем абсолютное время 
				if (Seconds - SecTempPrev > -TimeStabKolonna) //Если с момента начала стабилизации прошло больше заданного количества секунд
				{
					// Переходим к следующему этапу - отбору голов. 
					StateMachine = 4;
					if (BeepStateProcess) my_beep(BEEP_LONG);
					SecTempPrev = Seconds;
				}
				else
					break;
			}
		}
		else
			break;
	case 4: // Отбор голов
		UstPower = PowerRect;
		// Клапан отбора ректификата закроем на всякий случай
		KlOpen[KLP_SR] = 0;
		KlClose[KLP_SR] = 10;

		// Устанавливаем клапан отбора хвостов и голов в соответвии с установленнным ШИМ
		if (ProcChimOtbGlv > 0)
			KlOpen[KLP_GLV_HVS] = (timeChimRectOtbGlv / 100)*ProcChimOtbGlv;
		else
			KlOpen[KLP_GLV_HVS] = -ProcChimOtbGlv;

		KlClose[KLP_GLV_HVS] = timeChimRectOtbGlv - KlOpen[KLP_GLV_HVS];
		tStabSR = temps[TEMP_RK20];// Это температура, относительно которой будем стабилизировать отбор

    	 // Обычная ректификация
				if (temps[TEMP_KUB] < tEndRectOtbGlv)
				{  // Пока температура в кубе не выросла выше окончания отбора голов, продолжаем это состояни
					break;
				}

		// Если температура превысила указанный рубеж, то переходим в состояние отбора спирта-ректификата.
		// Клапан отбора голов и хвостов отключаем
		tStabSR = temps[TEMP_RK20];// Это температура, относительно которой будем стабилизировать отбор
		KlOpen[KLP_GLV_HVS] = 0;
		KlClose[KLP_GLV_HVS] = 10;
		StateMachine = 5;
		if (BeepStateProcess) my_beep(BEEP_LONG);
		SecTempPrev1 = Seconds; // Запомним время, когда произошел переход с фракции голов на отбор тела
		time1 = 5;
	case 5: // Ожидание, пока температура не вернется к состоянию стабилизации
	  // Если колонна слишком долго находится в режиме стопа, то температуру стабилизации примем за новую
		if (time1 == 0 && TimeRestabKolonna != 0)
		{
			tStabSR = temps[TEMP_RK20];// Это температура, относительно которой будем стабилизировать отбор
			if (BeepStateProcess) my_beep(BEEP_LONG);
			// Если время рестабилизации колонны меньше нуля, тогда при долгом простое переходим на отбор хвостов.
			if (TimeRestabKolonna < 0)
			{
					// При не фракционной перегонке
					StateMachine = 7;
					KlOpen[KLP_SR] = 0;// Отключаем клапана отбора СР
					KlClose[KLP_SR] = 10;
					if (BeepStateProcess) my_beep(BEEP_LONG);
			}
		}
		KlOpen[KLP_GLV_HVS] = 0;
		KlClose[KLP_GLV_HVS] = 10;
		KlOpen[KLP_SR] = 0;
		KlClose[KLP_SR] = 10;
		if (temps[TEMP_KUB] >= tEndRectOtbSR)
		{
			StateMachine = 7;
			if (BeepStateProcess) my_beep(BEEP_LONG);
			break;
		}
		if (temps[TEMP_RK20] > tStabSR)
		{
			break;
		}
		// Phisik: Если мы тут, то температура в колонне вернулась к tStabSR или мы подкрутили tStabSR выше,
		// запоминаем этот момент и идем собирать спирт 
		SecTempPrev = Seconds;
		StateMachine = 6;
		if (BeepStateProcess) my_beep(BEEP_LONG);
	case 6: // Отбор СР
	  //unsigned int timeChimRectOtbSR=1000;  // Шим отбора СР (в полупериодах сетевого напряжения в данном случае это около 10 секунд)
	  //unsigned char tDeltaRect=10;  // Дельта ректификации (в десятых градуса Цельсия) в данном случае - это 10 десятых, то есть 1 градус Цельсия
	  //unsigned int tEndRectOtbSR=965;  // Температура окончания отбора спирта-ректификата и начала отбора хвостов (в данном случе 96.5 С)
	  // Работа Клапана отбора голов зависит от работы царги пастеризации
		if (ProcChimOtbCP >= 0)
		{
			if (ProcChimOtbGlv > 0)
				KlOpen[KLP_GLV_HVS] = (timeChimRectOtbGlv / 100)*ProcChimOtbGlv;
			else
				KlOpen[KLP_GLV_HVS] = -ProcChimOtbGlv;

			KlOpen[KLP_GLV_HVS] = ((long)KlOpen[KLP_GLV_HVS] * (long)ProcChimOtbCP) / 100;
			KlClose[KLP_GLV_HVS] = timeChimRectOtbGlv - KlOpen[KLP_GLV_HVS];

		}
		else
		{
			KlOpen[KLP_GLV_HVS] = -ProcChimOtbCP;
			KlClose[KLP_GLV_HVS] = timeChimRectOtbSR - KlOpen[KLP_GLV_HVS];
		}
		// Устанавливаем ШИМ отбора СР
		UstPower = PowerRect;
		ProcChimSR = GetCHIMOtbor();  // Реализуется отбор по-шпоре, что в функции прописано то и будет возвращено.
		if (ProcChimSR > 0) KlOpen[KLP_SR] = ((timeChimRectOtbSR / 10)*ProcChimSR) / 10;
		else KlOpen[KLP_SR] = 0;
		KlClose[KLP_SR] = timeChimRectOtbSR - KlOpen[KLP_SR];
#if ADJUST_COLUMN_STAB_TEMP
		// Подхватываем текущую температуру, если мы тут в первый раз
		if (lastStableT < 500) {
			lastStableT = tStabSR;
			// Запоминаем текущее время
			SecTempPrev2 = millis();
		} else if(millis()-SecTempPrev2 > tStabCheckPeriod) {
			// Вычисляем средневзвешенную температуру ...
			lastStableT = (lastStableT+float(temps[TEMP_RK20])/tStabTimeConstant) / tStabAverageDivisor;
			// ... и новую температуру стабилизации
			tStabSR = round(lastStableT);
			// Запоминаем текущее время
			SecTempPrev2 = millis();
		} // if			
#endif // ADJUST_COLUMN_STAB_TEMP

		if (temps[TEMP_RK20] >= tStabSR + tDeltaRect) // Если текущая температура превысила базовую 
		{
			//        //Если температура превысилась менее, чем за одну минуту
			//        if (Seconds-SecTempPrev<60)
			//          {
			// произошел стоп - если значение количества температур в кубе меньше нуля, 
			// тогда запомним температуру в кубе за вычетом 0.1 градуса и процент ШИМ, при котором это произошло.
			if (CntCHIM < 0)
			{
				// Запоминаем температуру, когда произошел стоп за вычетом 0.1 градуса.
				tempK[-CntCHIM] = temps[TEMP_KUB] - 1;
				CHIM[-CntCHIM] = ProcChimSR;
				if (-CntCHIM < COUNT_CHIM - 1) CntCHIM--;
			}
			if (DecrementCHIM >= 0) ProcChimSR = ProcChimSR - DecrementCHIM;  // Тогда уменьшаем  ШИМ указанное число процентов в абсолютном выражении
			else
			{
				V3 = ((int)ProcChimSR* (int)-DecrementCHIM) / 100;
				// Процентное отношение может быть очень мало, поэтому если получилось нулевое значение, то вычтем единицу.
				if (V3 <= 0) V3 = 1;
				ProcChimSR = ProcChimSR - (char)V3; // Тогда увеличиваем ШИМ на число процентов в относительном выражении
			}
			if (ProcChimSR < minProcChimOtbSR) ProcChimSR = minProcChimOtbSR;
			// Если в результате стопа произошло уменьшение отбора до -1 и минимальный тоже -1, тогда переходим на хвосты.
			if ((ProcChimSR == -1 && minProcChimOtbSR == -1) && IspReg == 109)
			{
				StateMachine = 7;
				if (BeepStateProcess) my_beep(BEEP_LONG);
				KlOpen[KLP_SR] = 0;// Отключаем клапана отбора СР
				KlClose[KLP_SR] = 10;
				break;
			}
			// Если в результате стопа произошло уменьшение отбора до 0 и минимальный тоже 0, тогда переходим на окончание отбора.
			if ((ProcChimSR == 0 && minProcChimOtbSR == 0) && IspReg == 109)
			{
				StateMachine = 8;
				SecTempPrev = Seconds;// Запомним время, когда закончилась ректификация
				if (BeepStateProcess) my_beep(BEEP_LONG);
				break;
			}
			StateMachine = 5;
			// Взводим таймер для возможной рестабилизации колонны
			if (TimeRestabKolonna < 0) time1 = -TimeRestabKolonna;
			else time1 = TimeRestabKolonna;
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		else // if (temps[TEMP_RK20]>=tStabSR+tDeltaRect)
		{
			// Если температура не выросла более, чем за TimeAutoIncCHIM минут, прибавим ШИМ на 5%
			if (Seconds - SecTempPrev > TimeAutoIncCHIM)
			{
				// Шим прибавляем только если не дошли до минимального шима, если дошли, то считаем, что хватит играть ШИМом
				if (ProcChimSR > minProcChimOtbSR)
				{
					if (IncrementCHIM >= 0)   ProcChimSR = ProcChimSR + IncrementCHIM; // Тогда увеличиваем ШИМ указанное число процентов в абсолютном выражении
					else    ProcChimSR = ProcChimSR + ((int)ProcChimSR* (int)-IncrementCHIM) / 100; // Тогда увеличиваем ШИМ на число процентов в относительном выражении

					// if (ProcChimSR>95) ProcChimSR=95;   // Phisik: на кой клапаном щелкать, если ограничитель стоит?...
					if (ProcChimSR > 100) ProcChimSR = 100;
				}
				SecTempPrev = Seconds;// Запомним время, когда стабилизировалась температура
			}
		}	// if (temps[TEMP_RK20]>=tStabSR+tDeltaRect)

			// Если температура в кубе превысила температуру при которой надо отбирать СР
			if (temps[TEMP_KUB] >= tEndRectOtbSR)
			{
				StateMachine = 7;
				KlOpen[KLP_SR] = 0;// Отключаем клапана отбора СР
				KlClose[KLP_SR] = 10;
				if (BeepStateProcess) my_beep(BEEP_LONG);
			}
			else
				break;
	case 7: // Отбор Хвостов
		UstPower = PowerRect;

			KlOpen[KLP_SR] = 0;
			KlClose[KLP_SR] = 10;
			KlOpen[KLP_GLV_HVS] = (timeChimRectOtbGlv / 100) * 90;
			KlClose[KLP_GLV_HVS] = timeChimRectOtbGlv - KlOpen[KLP_GLV_HVS];
			if (temps[TEMP_KUB] >= tEndRect)
			{
				StateMachine = 8;
				SecTempPrev = Seconds;// Запомним время, когда закончилась ректификация
				if (BeepStateProcess) my_beep(BEEP_LONG);
			else
				break;
			{
				// Иначе переходим к завершению процесса
				StateMachine = 8;
				SecTempPrev = Seconds;// Запомним время, когда закончилась ректификация
				if (BeepStateProcess) my_beep(BEEP_LONG);
			}
		}
	case 8:// Ждем три минуты для окончания подачи воды
		UstPower = 0;

		KlOpen[KLP_GLV_HVS] = 0;  // Отключаем клапана отбора хвостов
		KlClose[KLP_GLV_HVS] = 10;
		KlOpen[KLP_SR] = 0;
		KlClose[KLP_SR] = 10;

		if (Seconds - SecTempPrev > 180 + ((int)(FlAvtonom >> 1)) * 60)
		{
			// Переводим автомат в конечное состояние
			StateMachine = 100;
			SecondsEnd = Seconds;
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		break;
	case 9:
	case 101: // Превышение температуры в ТСА!!!
	case 102: // Превышение давления
		my_beep(2 * BEEP_LONG);
	case 100:// Конечное состояние автомата
	  // Отключаем на всякий случай все!
		if (StateMachine == 100 && BeepEndProcess) my_beep(BEEP_LONG);

		UstPower = 0;
		CloseAllKLP();
		flAllOff = 1;
		break;
	  }
	}

void ProcessSimpleDistill()
{
	if (StateMachine < 4)
	{ // Переводим автомат в стадию завершения 
		StateMachine = 4;
		SecondsEnd = 2 * 60 + ((int)(FlAvtonom >> 1)) * 60;// Через две минуты отключим воду
		SecTempPrev = Seconds;
		if (BeepStateProcess) my_beep(BEEP_LONG);
	}
	// Проверяем температуру в ТСА
	if (temps[TEMP_TSA] >= MAX_TEMP_TSA)
	{
		StateMachine = 101; // Переводим автомат в состояние аварии по ТСА.
		UstPower = 0;
	}
	switch (StateMachine)
	{
	case 0: // Процесс не запущен
		break;
	case 1: // Начало процесса
		PrepareProcess();

		KlOpen[KLP_VODA] = PER_KLP_OPEN;
		KlClose[KLP_VODA] = PER_KLP_CLOSE;
		StateMachine = 2;
		if (BeepStateProcess) my_beep(BEEP_LONG);
		flAllOff = 0;
	case 2: // Ожидание, пока прогреется термометр в дефлегматоре
		UstPower = Power; // Устанавливаем максимальную мощность для разгона
		// Если температура в дефлегматоре меньше 70 градусов и датчик дефлегматора в принципе подключен, тогда ждем, пока
		// дефлегматор прогреется, чтобы запустить воду в холодильник (это для некоторой экономии воды)
		if (temps[TEMP_DEFL] < TempDeflBegDistil && ds1820_devices>1 || (TempDeflBegDistil < 0 && temps[TEMP_KUB] < -TempDeflBegDistil)) 
		break;

		// Подаем питание на клапан подачи воды холодильника
		// для этого синхронизируем его с клапаном общей подачи воды (возможно, при этом будет меньше гидроударов, хотя я их и так не наблюдаю)
		KlOpen[KLP_HLD] = KlOpen[KLP_VODA];
		KlClose[KLP_HLD] = KlClose[KLP_VODA];
		KlState[KLP_HLD] = KlState[KLP_VODA];
		KlCount[KLP_HLD] = KlCount[KLP_VODA];
		StateMachine = 3;
		if (BeepStateProcess) my_beep(BEEP_LONG);
	case 3:// Ждем, пока температура в кубе не превысит установленную
		UstPower = PowerDistil; // Устанавливаем максимальную мощность для разгона

		if (IspReg == 104) TekTemp = Temp1P; //Текущее состояние - первый недробный перегон
		if (IspReg == 106) TekTemp = Temp2P; //Текущее состояние - второй дробный 
		if (IspReg == 107) TekTemp = Temp3P; //Текущее состояние - третий дробный

		if (temps[TEMP_KUB] >= TekTemp)
		{
			StateMachine = 4;
			SecondsEnd = 2 * 60 + ((int)(FlAvtonom >> 1)) * 60;// Через две минуты отключим воду
			SecTempPrev = Seconds;
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		else
			break;
	case 4:// Ждем минуту для окончания подачи воды
		UstPower = 0;
    SecondsEnd=SecondsEnd-(Seconds-SecTempPrev);
    SecTempPrev=Seconds;
		if (SecondsEnd <= 0)
		{
			// Переводим автомат в конечное состояние
			StateMachine = 100;
			SecondsEnd = Seconds;
			if (BeepStateProcess) my_beep(BEEP_LONG);
		}
		break;
	case 101: // Превышение температуры в ТСА!!!
		my_beep(3 * BEEP_LONG);
	case 100:// Конечное состояние автомата
	  // Отключаем на всякий случай все!
		if (BeepEndProcess) my_beep(BEEP_LONG);
		UstPower = 0;
		CloseAllKLP();
		flAllOff = 1;
		break;
	}
}
